<script setup lang="ts">
////////////////////////////////
// IMPORT
////////////////////////////////
import { useConnectionStore } from "@/stores/useConnectionStore";
import { onMounted } from "vue";

////////////////////////////////
// DATA
////////////////////////////////
const connectionStore = useConnectionStore();

const connections = ref([]);
const loading = ref(false);
const selectedConnectionID = ref("");

const connectionEditionDialog = ref(false);

const headers = [
  { title: "Name", key: "name" },
  { title: "Connector", key: "connector.name" },
  { title: "", key: "action", align: "end", sortable: false, width: "30px" },
];
const search = ref("");

////////////////////////////////
// METHODS
////////////////////////////////
async function checkConnection(connectionId: string) {
  try {
    loading.value = true;
    // Trigger the check connection
    await connectionStore.checkConnection(connectionId);
    // Optionally refetch the connections after the check
    await connectionStore.fetchConnections();
  } catch (error) {
    console.error("Error checking connection:", error);
  } finally {
    loading.value = false;
  }
}

////////////////////////////////
// LIFECYCLE
////////////////////////////////
onMounted(async () => {
  loading.value = true;
  await connectionStore.fetchConnections();
  connections.value = connectionStore.connectionMap;
  loading.value = false;
});
</script>

<template>
  <div class="pa-4">
    <v-sheet class="me-auto" style="overflow: hidden; white-space: nowrap; text-overflow: ellipsis">
      <h1>{{ $t("my_workspace_connections") }}</h1>
    </v-sheet>
    <hr class="mb-3">
    <v-sheet class="d-flex align-center pa-1">
      <h2 class="mb-3 me-auto">
        Connections
        <v-chip size="small" class="me-2">
          {{ connectionStore.connectionMap.size }}
        </v-chip>
      </h2>
      <v-btn
        color="primary"
        icon="mdi-plus"
        density="comfortable"
        @click="connectionEditionDialog = true"
      />
      <v-text-field
        v-model="search"
        hide-details
        placeholder=""
        label="Search"
        density="compact"
        class="ms-4"
        prepend-inner-icon="mdi-magnify"
        single-line
        style="max-width: 250px"
      />
    </v-sheet>
    <v-data-table
      :headers="headers"
      :items="Object.values(Object.fromEntries(connections))"
      class="elevation-1"
      item-value="title"
      :search="search"
      :loading="loading"
    >
      <template v-slot:loading>
        <v-skeleton-loader type="table-row@10" />
      </template>
      <template v-slot:[`item.name`]="{ value, item }">
        <div>
          <v-badge
            dot
            :color="connectionStore.getStatus(item.id, undefined).color"
            inline
          />
          {{ value ? value : "Untitled" }}
        </div>
      </template>
      <template v-slot:[`item.connector.name`]="{ value, item }">
        <div>
          <img
            class="align-self-center me-4"
            :src="item.connector.icon"
            alt=""
            style="height: 1em"
          >
          {{ value ? value : "No name" }}
        </div>
      </template>
      <template v-slot:[`item.action`]="{ item }">
        <div>
          <v-menu location="end">
            <template v-slot:activator="{ props }">
              <v-btn
                icon="mdi-dots-vertical"
                variant="plain"
                size="small"
                v-bind="props"
              />
            </template>
            <v-list density="compact">
              <v-list-item @click="checkConnection(item.id)">
                <template v-slot:prepend>
                  <v-icon icon="mdi mdi-reload" />
                </template>
                <span>Refresh</span>
              </v-list-item>
              <v-list-item
                @click="
                  selectedConnectionID = item.id;
                  connectionEditionDialog = true;
                "
              >
                <template v-slot:prepend>
                  <v-icon icon="mdi-cog" />
                </template>
                <span>Edit credentials</span>
              </v-list-item>
              <v-list-item @click="connectionStore.deleteConnection(item.id)">
                <template v-slot:prepend>
                  <v-icon icon="mdi-trash-can-outline" color="error" />
                </template>
                <span>Delete credentials</span>
              </v-list-item>
            </v-list>
          </v-menu>
        </div>
      </template>
    </v-data-table>
  </div>
  <ConnectionEdition
    :connectionEditionDialog="connectionEditionDialog"
    :selectedConnectionID="selectedConnectionID"
    @connectionEditionDialog="connectionEditionDialog = false"
    @selectedConnectionID="selectedConnectionID = ''"
  />
</template>

<style></style>
